#define STRICT				//   
#include <windows.h>		//   windows
#include <commctrl.h>		//     windows

#include "ImageListEx.h"



///////////////////////////////////////////////////////////////
//
//         
// 
///////////////////////////////////////////////////////////////
//
//        ,
//   .
//      ,   
//  ,   Windows XP   
//   .
// 
HICON Icon_CopyAsGreyScale(HICON hIcon)
{
	ICONINFO iconinfo = { 0 };
	HICON hicon = NULL;

//       -
//    .
//    (!)      
// 
	if(GetIconInfo(hIcon, &iconinfo))
	{
	//    , ..  
	//  
		if(iconinfo.hbmColor)
		{
		//   
			BITMAP bm = {0};
			GetObject(iconinfo.hbmColor, sizeof(bm), &bm);

		//       
			HDC hDC = GetDC(GetDesktopWindow());

		// ...   
			HDC dcColor = CreateCompatibleDC(hDC);
			HGDIOBJ oBmpColor = SelectObject(dcColor, iconinfo.hbmColor);

		// ...   (   )
			HDC dcMask = CreateCompatibleDC(hDC);
			HGDIOBJ oBmpMask = SelectObject(dcMask, iconinfo.hbmMask);

		//    
			for(int y=0;y<bm.bmHeight;y++)
			for(int x=0;x<bm.bmWidth;x++)
			{
			//      
				if(!GetPixel(dcMask, x, y))
				{
				//  
					COLORREF cl = GetPixel(dcColor, x, y);

				//    
					int c = ( GetRValue(cl) + GetGValue(cl) + GetBValue(cl) ) / 3;

				//   ,    
					SetPixel(dcColor, x, y, RGB(c, c, c));
				}
			}

		//  ...
		// ...    
			SelectObject(dcMask, oBmpMask);
			DeleteDC(dcMask);

		// ...    
			SelectObject(dcColor, oBmpColor);
			DeleteDC(dcColor);

		//   
			ReleaseDC(GetDesktopWindow(), hDC);
		}

	//       
		hicon = CreateIconIndirect(&iconinfo);

	// .. - GetIconInfo()  CreateIconIndirect() 
	//  ,   - 
		if(iconinfo.hbmColor) DeleteObject(iconinfo.hbmColor);
		if(iconinfo.hbmMask) DeleteObject(iconinfo.hbmMask);
	}

//     ,  NULL   
	return hicon;
}






///////////////////////////////////////////////////////////////
//
//        50%
//
///////////////////////////////////////////////////////////////
//
//     :
//     50%  , 
//    .
//      ,   
//  ,   Windows XP   
//   .
// 
HICON Icon_CopyAsBlend50(HICON hIcon)
{
	ICONINFO iconinfo = { 0 };
	HICON hicon = NULL;

//       -
//    .
//    (!)      
// 
	if(GetIconInfo(hIcon, &iconinfo))
	{
	//    , ..  
	//  
		if(iconinfo.hbmColor)
		{
		//   
			BITMAP bm = {0};
			GetObject(iconinfo.hbmColor, sizeof(bm), &bm);

		//       
			HDC hDC = GetDC(GetDesktopWindow());

		// ...   
			HDC dcColor = CreateCompatibleDC(hDC);
			HGDIOBJ oBmpColor = SelectObject(dcColor, iconinfo.hbmColor);

		// ...   (   )
			HDC dcMask = CreateCompatibleDC(hDC);
			HGDIOBJ oBmpMask = SelectObject(dcMask, iconinfo.hbmMask);

		//    
			for(int y=0;y<bm.bmHeight;y++)
			for(int x=0;x<bm.bmWidth;x++)
			{
			//      
				if(!GetPixel(dcMask, x, y))
				{
				//  
					COLORREF cl = GetPixel(dcColor, x, y);

				//   
					int cR = GetRValue(cl);
					int cG = GetGValue(cl);
					int cB = GetBValue(cl);

				//    
				// ,  :  [0;255] -> [96;224]
					cR = cR * (224-96) / 256 + 96;
					cG = cG * (224-96) / 256 + 96;
					cB = cB * (224-96) / 256 + 96;

				//    
					SetPixel(dcColor, x, y, RGB(cR, cG, cB));
				}
			}

		//  ...
		// ...    
			SelectObject(dcMask, oBmpMask);
			DeleteDC(dcMask);

		// ...    
			SelectObject(dcColor, oBmpColor);
			DeleteDC(dcColor);

		//   
			ReleaseDC(GetDesktopWindow(), hDC);
		}

	//       
		hicon = CreateIconIndirect(&iconinfo);

	// .. - GetIconInfo()  CreateIconIndirect() 
	//  ,   - 
		if(iconinfo.hbmColor) DeleteObject(iconinfo.hbmColor);
		if(iconinfo.hbmMask) DeleteObject(iconinfo.hbmMask);
	}

//     ,  NULL   
	return hicon;
}






///////////////////////////////////////////////////////////////
//
//         
//
///////////////////////////////////////////////////////////////
//
//        
// Icon_CopyAsGreyScale().
//        
//    ,  
//  Icon_CopyAsGreyScale()
// 
HIMAGELIST ImageList_CopyAsGreyScale(HIMAGELIST hImageList)
{
	HICON hIcon, hIcon0;
	int cx, cy;
	unsigned i;

//  - 
	unsigned cnt = ImageList_GetImageCount(hImageList);

//  
	if(!ImageList_GetIconSize(hImageList, &cx, &cy)) return NULL;

//        - 
	HIMAGELIST himlDestination = ImageList_Create(cx, cy, ILC_COLOR16|ILC_MASK, cnt, 0);

//    ,  
	if(!himlDestination) return NULL;

//    
	for(i=0;i<cnt;i++)
	{
	//  ()   -    
		hIcon = (HICON)ImageList_GetIcon(hImageList, (int)i, ILD_TRANSPARENT);

	//     
		hIcon0 = Icon_CopyAsGreyScale(hIcon);

	//     
		ImageList_AddIcon(himlDestination, hIcon0);

	//    , ..
	//  ImageList_GetIcon()  Icon_CopyAsGreyScale()
	//  ,  ImageList_AddIcon()  
	//   ( )
		DestroyIcon(hIcon0);
		DestroyIcon(hIcon);
	}

	//   
	return himlDestination;
}






///////////////////////////////////////////////////////////////
//
//        50%
//
///////////////////////////////////////////////////////////////
//
//      Icon_CopyAsBlend50().
//        
//    ,  
//  Icon_CopyAsBlend50()
// 
HIMAGELIST ImageList_CopyAsBlend50(HIMAGELIST hImageList)
{
	HICON hIcon, hIcon0;
	int cx, cy;
	unsigned i;

//  - 
	unsigned cnt = ImageList_GetImageCount(hImageList);

//  
	if(!ImageList_GetIconSize(hImageList, &cx, &cy)) return NULL;

//        - 
	HIMAGELIST himlDestination = ImageList_Create(cx, cy, ILC_COLOR16|ILC_MASK, cnt, 0);

//    ,  
	if(!himlDestination) return NULL;

//    
	for(i=0;i<cnt;i++)
	{
	//  ()   -    
		hIcon = (HICON)ImageList_GetIcon(hImageList, (int)i, ILD_TRANSPARENT);

	//    50%  
		hIcon0 = Icon_CopyAsBlend50(hIcon);

	//     
		ImageList_AddIcon(himlDestination, hIcon0);

	//    , ..
	//  ImageList_GetIcon()  Icon_CopyAsBlend50()
	//  ,  ImageList_AddIcon()  
	//   ( )
		DestroyIcon(hIcon0);
		DestroyIcon(hIcon);
	}

	//   
	return himlDestination;
}






///////////////////////////////////////////////////////////////
//
//        50% 
//                     
//
///////////////////////////////////////////////////////////////
//
//      
//  Icon_CopyAsGreyScale()  Icon_CopyAsBlend50()
//        
//    ,  
//  Icon_CopyAsGreyScale()  Icon_CopyAsBlend50()
// 
HIMAGELIST ImageList_CopyAsDisabled(HIMAGELIST hImageList)
{
	HICON hIcon, hIcon0, hIcon1;
	int cx, cy;
	unsigned i;

//  - 
	unsigned cnt = ImageList_GetImageCount(hImageList);

//  
	if(!ImageList_GetIconSize(hImageList, &cx, &cy)) return NULL;

//        - 
	HIMAGELIST himlDestination = ImageList_Create(cx, cy, ILC_COLOR16|ILC_MASK, cnt, 0);

//    ,  
	if(!himlDestination) return NULL;

//    
	for(i=0;i<cnt;i++)
	{
	//  ()   -    
		hIcon = (HICON)ImageList_GetIcon(hImageList, (int)i, ILD_TRANSPARENT);

	//    50%  
		hIcon0 = Icon_CopyAsBlend50(hIcon);

	//         
		hIcon1 = Icon_CopyAsGreyScale(hIcon0);

	//     
		ImageList_AddIcon(himlDestination, hIcon1);

	//    , ..
	//  ImageList_GetIcon(), Icon_CopyAsGreyScale()
	//  Icon_CopyAsBlend50()  ,
	//  ImageList_AddIcon()   
	//  ( )
		DestroyIcon(hIcon1);
		DestroyIcon(hIcon0);
		DestroyIcon(hIcon);
	}

	//   
	return himlDestination;
}
